commit:     f1dad43789d67aaf92f62c80e5b211bdd203b4f9
Author:     Thomas Raschbacher <lordvan <AT> gentoo <DOT> org>
AuthorDate: Wed Feb  7 21:38:05 2024 +0000
Commit:     Thomas Raschbacher <lordvan <AT> gentoo <DOT> org>
CommitDate: Wed Feb  7 21:39:42 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f1dad437

app-antivirus/clamav: add 1.2.2

Signed-off-by: Thomas Raschbacher <lordvan <AT> gentoo.org>

 app-antivirus/clamav/Manifest            |   1 +
 app-antivirus/clamav/clamav-1.2.2.ebuild | 393 +++++++++++++++++++++++++++++++
 2 files changed, 394 insertions(+)

diff --git a/app-antivirus/clamav/Manifest b/app-antivirus/clamav/Manifest
index fe03a3065533..936afb9ab0ef 100644
--- a/app-antivirus/clamav/Manifest
+++ b/app-antivirus/clamav/Manifest
@@ -34,6 +34,7 @@ DIST clamav-1.0.3.tar.gz 10341567 BLAKE2B 
9530c5e57cf4908ee15800a5aa50b8defc7b86
 DIST clamav-1.1.0.tar.gz 10297532 BLAKE2B 
36629f9bf23a55591002517ecbad798484d351f060220ab554797d4acd356b89cc68f83f81a415d532c51fde33f1882ddaaa847c1935abb6b12d571b3976d66f
 SHA512 
1a1cfd2e43518eafa127304704193e96162410d676fca6c868fd42f871412bbe91f379bb5c74abd89c14cfa3d580339bb79c10868776e46427a7afd9b55dc851
 DIST clamav-1.1.3.tar.gz 10304772 BLAKE2B 
2bf2f7822d8ed7bfa6040312345d6dfbf5149e6ee60d10d46fe0683b56028e0c72b3371e9b9bc4c780051f11899d7405a35484a3f1deafdfd9b0c18613f52b36
 SHA512 
1fab8754e793938182dd6a5f2742c4f3e236177e150ab1f1a6064d2e0f33ae1329396ba14ba12f72eee505fb6c8e6f302377ec7e3d5f172a52d1ec89b23da072
 DIST clamav-1.2.1.tar.gz 10370350 BLAKE2B 
bc875a92adecffca3b65976376529043a27520bc3821da2d7563e5cb69733ecf291a2800d2a3ad65b1cb0cc4f35a1605e29e27128dd0a775740a9f640c3436ef
 SHA512 
abe0c1a84cb399df00485bf0f8726f01cb84ad129e40642b60146e5880981f7216d9da354e7569004711e417cf8b757ae33a6d5a39b615bce7c7e21e97c9df1d
+DIST clamav-1.2.2.tar.gz 10372690 BLAKE2B 
47940236e38296ac908be4c5d1c5ce8bbc9ec5c69fa87b2472c941d2de9642e0ab6a59c63038aa706079e8efeb161083db69ad03eaaf27a6d05f4f1a5bb70aff
 SHA512 
32562230f367a230f70dfca5ed5000ee8829a0da7452b0113e9dbaa47ef6b21901001f741b0e52ce52c02fe8f834bd559bcbdf1ea20495bead9c4976c3a4cc92
 DIST clang-sys-1.4.0.crate 38679 BLAKE2B 
d15bdae2142ed26b4f6bd037bd2062e8c4b7b87fc5b749b872a95ff1952d000066c255aa0984e5f9c4a5c88066db4a20cfd048db4ba5a59b331d5ffa5e9a281d
 SHA512 
062189bb0a341e2e85de4987f4b564c1fc69e4005c9c42cfedb61dee5f48db9126a8114d1d97be1b9c21b8c885243751232fbe8cf532e1d2be593308fe45216a
 DIST clang-sys-1.6.1.crate 41346 BLAKE2B 
b70104e6c6b3c1b85caa111c2b1fb2c20d30eeb85059bc616afc49bce9409f7ee2dd8b800750a466accad6a74ef29d10c6a2ee4459d854a2c0c54050ff51cc4b
 SHA512 
a6c62c1d3faae3796f5e7d98ed4f1a8119f0ffaf8fceee8e728cd4da57b0140e82631012450bb0c551cd13814a97065e9e47015320707a87bdfbb6fd317e952c
 DIST clap-2.34.0.crate 202210 BLAKE2B 
f383adf1d757ac4b68995132b33837686ce451f85a02a8d05d2c746da398510d05d46330f3efade063c3952aacb1754cdac73dd0afcae0df5340a89f9353aa1c
 SHA512 
c648a761b9996a7e7464a538bb53621bae22090b846a42c3b729beca3363958ae67e3da9f93f58b10a10e043cadf7ff930388680d168646178c2824177832db8

diff --git a/app-antivirus/clamav/clamav-1.2.2.ebuild 
b/app-antivirus/clamav/clamav-1.2.2.ebuild
new file mode 100644
index 000000000000..1bd9569ed03f
--- /dev/null
+++ b/app-antivirus/clamav/clamav-1.2.2.ebuild
@@ -0,0 +1,393 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+# Upstream are working on updating clamav's LLVM bytecode interpreter to work
+# with later versions of LLVM, but it's not ready yet. See:
+# https://github.com/Cisco-Talos/clamav/issues/581
+# This does not impact the ability of the package to build with llvm/clang 
otherwise.
+LLVM_MAX_SLOT=13
+PYTHON_COMPAT=( python3_{10..12} )
+
+CRATES="
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]+wasi-snapshot-preview1
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+       [email protected]
+"
+
+inherit cargo cmake flag-o-matic llvm python-any-r1 systemd tmpfiles
+
+MY_P=${P//_/-}
+
+DESCRIPTION="Clam Anti-Virus Scanner"
+HOMEPAGE="https://www.clamav.net/";
+SRC_URI="https://github.com/Cisco-Talos/clamav/archive/refs/tags/${MY_P}.tar.gz
+       ${CARGO_CRATE_URIS}"
+S=${WORKDIR}/clamav-${MY_P}
+
+LICENSE="Apache-2.0 BSD GPL-2 ISC MIT MPL-2.0 Unicode-DFS-2016 ZLIB"
+# 0/sts (short term support) if not an LTS release
+SLOT="0/sts"
+if [[ ${PV} != *_rc* ]] ; then
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~ppc ~ppc64 ~riscv ~sparc ~x86 
~amd64-linux ~x86-linux ~ppc-macos"
+fi
+
+IUSE="doc clamonacc +clamapp experimental jit libclamav-only milter rar 
selinux +system-mspack systemd test"
+
+REQUIRED_USE="libclamav-only? ( !clamonacc !clamapp !milter )
+       clamonacc? ( clamapp )
+       milter? ( clamapp )
+       test? ( !libclamav-only )"
+
+RESTRICT="!test? ( test )"
+
+# Require acct-{user,group}/clamav at build time so that we can set
+# the permissions on /var/lib/clamav in src_install rather than in
+# pkg_postinst; calling "chown" on the live filesystem scares me.
+COMMON_DEPEND="
+       acct-group/clamav
+       acct-user/clamav
+       app-arch/bzip2
+       dev-libs/json-c:=
+       dev-libs/libltdl
+       dev-libs/libpcre2:=
+       dev-libs/libxml2
+       dev-libs/openssl:=
+       >=sys-libs/zlib-1.2.2:=
+       virtual/libiconv
+       !libclamav-only? ( net-misc/curl )
+       clamapp? ( sys-libs/ncurses:= net-misc/curl )
+       elibc_musl? ( sys-libs/fts-standalone )
+       jit? ( <sys-devel/llvm-$((${LLVM_MAX_SLOT} + 1)):= )
+       milter? ( mail-filter/libmilter:= )
+       rar? ( app-arch/unrar )
+       system-mspack? ( dev-libs/libmspack )
+       test? ( dev-python/pytest )
+"
+# rust-bin < 1.71 has an executable stack
+# which is not supported on selinux #911589
+BDEPEND="
+       virtual/pkgconfig
+       >=virtual/rust-1.71
+       doc? ( app-text/doxygen )
+       test? (
+               ${PYTHON_DEPS}
+               $(python_gen_any_dep 'dev-python/pytest[${PYTHON_USEDEP}]')
+       )
+"
+
+DEPEND="${COMMON_DEPEND}
+       test? ( dev-libs/check )"
+
+RDEPEND="${COMMON_DEPEND}
+       selinux? ( sec-policy/selinux-clamav )"
+
+python_check_deps() {
+       python_has_version -b "dev-python/pytest[${PYTHON_USEDEP}]"
+}
+
+pkg_setup() {
+       use jit && llvm_pkg_setup
+       use test && python-any-r1_pkg_setup
+}
+
+src_configure() {
+       use elibc_musl && append-ldflags -lfts
+       use ppc64 && append-flags -mminimal-toc
+
+       local mycmakeargs=(
+               -DAPP_CONFIG_DIRECTORY="${EPREFIX}"/etc/clamav
+               -DBYTECODE_RUNTIME=$(usex jit llvm interpreter)
+               -DCLAMAV_GROUP="clamav"
+               -DCLAMAV_USER="clamav"
+               -DDATABASE_DIRECTORY="${EPREFIX}"/var/lib/clamav
+               -DENABLE_APP=$(usex clamapp ON OFF)
+               -DENABLE_CLAMONACC=$(usex clamonacc ON OFF)
+               -DENABLE_DOXYGEN=$(usex doc)
+               -DENABLE_EXPERIMENTAL=$(usex experimental ON OFF)
+               -DENABLE_EXTERNAL_MSPACK=$(usex system-mspack ON OFF)
+               -DENABLE_JSON_SHARED=ON
+               -DENABLE_MAN_PAGES=ON
+               -DENABLE_MILTER=$(usex milter ON OFF)
+               -DENABLE_SHARED_LIB=ON
+               -DENABLE_STATIC_LIB=OFF
+               -DENABLE_SYSTEMD=$(usex systemd ON OFF)
+               -DENABLE_TESTS=$(usex test ON OFF)
+               -DENABLE_UNRAR=$(usex rar ON OFF)
+               -DOPTIMIZE=ON
+       )
+
+       if use test ; then
+               # https://bugs.gentoo.org/818673
+               # Used to enable some more tests but doesn't behave well in
+               # sandbox necessarily(?) + needs certain debug symbols present
+               # in e.g. glibc.
+               mycmakeargs+=(
+                       -DCMAKE_DISABLE_FIND_PACKAGE_Valgrind=ON
+                       -DPYTHON_FIND_VERSION="${EPYTHON#python}"
+               )
+       fi
+
+       if use jit ; then
+               # Suppress CMake warnings that variables aren't consumed if we 
aren't using LLVM
+               # 
https://github.com/Cisco-Talos/clamav/blob/main/INSTALL.md#llvm-optional-see-bytecode-runtime-section
+               # 
https://github.com/Cisco-Talos/clamav/blob/main/INSTALL.md#bytecode-runtime
+               mycmakeargs+=(
+                       -DLLVM_ROOT_DIR="$(get_llvm_prefix -d ${LLVM_MAX_SLOT})"
+                       -DLLVM_FIND_VERSION="$(best_version 
sys-devel/llvm:${LLVM_MAX_SLOT} | cut -c 16-)"
+               )
+       fi
+
+       cmake_src_configure
+}
+
+src_install() {
+       cmake_src_install
+       # init scripts
+       newinitd "${FILESDIR}/clamd.initd" clamd
+       newinitd "${FILESDIR}/freshclam.initd" freshclam
+       use clamonacc && \
+               newinitd "${FILESDIR}/clamonacc.initd" clamonacc
+       use milter && \
+               newinitd "${FILESDIR}/clamav-milter.initd" clamav-milter
+
+       if ! use libclamav-only ; then
+               if use systemd ; then
+                       # The tmpfiles entry is behind USE=systemd because the
+                       # upstream OpenRC service files should (and do) ensure 
that
+                       # the directories they need exist and have the correct
+                       # permissions without the help of opentmpfiles. There 
are
+                       # years-old root exploits in opentmpfiles, the design is
+                       # fundamentally flawed, and the maintainer is not up to
+                       # the task of fixing it.
+                       dotmpfiles "${FILESDIR}/tmpfiles.d/clamav.conf"
+                       systemd_newunit "${FILESDIR}/clamd_at.service-0.104.0" 
"[email protected]"
+                       systemd_dounit "${FILESDIR}/clamd.service"
+                       systemd_newunit "${FILESDIR}/freshclamd.service-r1" \
+                                                       "freshclamd.service"
+               fi
+
+               if use clamapp ; then
+                       # Modify /etc/{clamd,freshclam}.conf to be usable out 
of the box
+                       sed -e "s:^\(Example\):\# \1:" \
+                               -e "s/^#\(PidFile .*\)/\1/" \
+                               -e "s/^#\(LocalSocket .*\)/\1/" \
+                               -e "s/^#\(User .*\)/\1/" \
+                               -e "s:^\#\(LogFile\) .*:\1 
${EPREFIX}/var/log/clamav/clamd.log:" \
+                               -e "s:^\#\(LogTime\).*:\1 yes:" \
+                               -e "s/^#\(DatabaseDirectory .*\)/\1/" \
+                               "${ED}"/etc/clamav/clamd.conf.sample > \
+                               "${ED}"/etc/clamav/clamd.conf || die
+
+                       sed -e "s:^\(Example\):\# \1:" \
+                               -e "s/^#\(PidFile .*\)/\1/" \
+                               -e "s/^#\(DatabaseOwner .*\)/\1/" \
+                               -e "s:^\#\(UpdateLogFile\) .*:\1 
${EPREFIX}/var/log/clamav/freshclam.log:" \
+                               -e "s:^\#\(NotifyClamd\).*:\1 
${EPREFIX}/etc/clamav/clamd.conf:" \
+                               -e "s:^\#\(ScriptedUpdates\).*:\1 yes:" \
+                               -e "s/^#\(DatabaseDirectory .*\)/\1/" \
+                               "${ED}"/etc/clamav/freshclam.conf.sample > \
+                               "${ED}"/etc/clamav/freshclam.conf || die
+
+                       if use milter ; then
+                               # Note: only keep the "unix" ClamdSocket and 
MilterSocket!
+                               sed -e "s:^\(Example\):\# \1:" \
+                                       -e "s/^#\(PidFile .*\)/\1/" \
+                                       -e "s/^#\(ClamdSocket unix:.*\)/\1/" \
+                                       -e "s/^#\(User .*\)/\1/" \
+                                       -e "s/^#\(MilterSocket unix:.*\)/\1/" \
+                                       -e "s:^\#\(LogFile\) .*:\1 
${EPREFIX}/var/log/clamav/clamav-milter.log:" \
+                                       
"${ED}"/etc/clamav/clamav-milter.conf.sample > \
+                                       "${ED}"/etc/clamav/clamav-milter.conf 
|| die
+
+                               systemd_newunit 
"${FILESDIR}/clamav-milter.service-0.104.0" clamav-milter.service
+                       fi
+
+                       local i
+                       for i in clamd freshclam clamav-milter
+                       do
+                               if [[ -f "${ED}"/etc/"${i}".conf.sample ]] ; 
then
+                                       mv "${ED}"/etc/"${i}".conf{.sample,} || 
die
+                               fi
+                       done
+
+                       # These both need to be writable by the clamav user
+                       # TODO: use syslog by default; that's what it's for.
+                       diropts -o clamav -g clamav
+                       keepdir /var/lib/clamav
+                       keepdir /var/log/clamav
+               fi
+       fi
+
+       if use doc ; then
+               local HTML_DOCS=( docs/html/. )
+               einstalldocs
+       fi
+
+       # Don't install man pages for utilities we didn't install
+       if use libclamav-only ; then
+               rm -r "${ED}"/usr/share/man || die
+       fi
+
+       find "${ED}" -name '*.la' -delete || die
+}
+
+pkg_postinst() {
+       if ! use libclamav-only ; then
+               if use systemd ; then
+                       tmpfiles_process clamav.conf
+               fi
+       fi
+
+       if use milter ; then
+               elog "For simple instructions how to setup the clamav-milter 
read the"
+               elog "clamav-milter.README.gentoo in /usr/share/doc/${PF}"
+       fi
+
+       local databases=( "${EROOT}"/var/lib/clamav/main.c[lv]d )
+       if [[ ! -f "${databases}" ]] ; then
+               ewarn "You must run freshclam manually to populate the virus 
database"
+               ewarn "before starting clamav for the first time."
+       fi
+
+        if ! systemd_is_booted ; then
+               ewarn "This version of ClamAV provides separate OpenRC services"
+               ewarn "for clamd, freshclam, clamav-milter, and clamonacc. The"
+               ewarn "clamd service now starts only the clamd daemon itself. 
You"
+               ewarn "should add freshclam (and perhaps clamav-milter) to any"
+               ewarn "runlevels that previously contained clamd."
+       fi
+}

Reply via email to